#include"map.h"

bool C_map::isInsideofMap(int x,int y){
	if(x<0||mSizeX<=x||y<0||mSizeY<=y){
		return false;
	}
	return true;
}

C_map::C_map(const string& mapsrc){	//}bv̓ǂݍ
	mSizeX=0,mSizeY=0;
	mBlocks=0;
	mPlayerX=0,mPlayerY=0;
	int cnt=0;

	ifstream map(mapsrc);
	if(map.fail()){
		cerr<<"file open error"<<endl;
		exit(EXIT_FAILURE);
	}
	string str1,str2;
	while(getline(map,str1)){
		str2+=str1;
		mSizeY++;
	}
	str2+='\0';
	mSizeX=str1.size();

	mBlocks=new C_block[mSizeY*mSizeX];	//ubN̔zƂă}bvmہ@ȉĂ

	while(str2[cnt]){
		switch(str2[cnt]){
		case '#':
			mBlocks[cnt].set(true,WALL);
			break;
		case ' ':
			mBlocks[cnt].set(true,SPACE);
			break;
		case '.':
			mBlocks[cnt].set(true,GOAL);
			break;
		case 'p':
			mBlocks[cnt].set(true,PLAYER);
			//vC[̏W̊l
			mPlayerY=cnt/mSizeX;
			mPlayerX=cnt%mSizeX;
			break;
		case 'P':
			mBlocks[cnt].set(true,PLAYER|GOAL);
			break;
		case 'o':
			mBlocks[cnt].set(true,NIMOTSU);
			break;
		case 'O':
			mBlocks[cnt].set(true,NIMOTSU|GOAL);
			break;
		default:
			cerr<<"unknown block type"<<endl;
			exit(EXIT_FAILURE);
			break;
		}

		cnt++;
	}
}

C_map::~C_map(){
	delete[] mBlocks;
	mBlocks=0;
}

void C_map::update(const string& input){
	
	int mem_x1=0,mem_y1=0;		//isɂЂƂi񂾂Ƃۂ̍W
	C_block mem_block1;			//isɂЂƂi񂽂Ƃۂ̃ubN
	mem_block1.setflag(0);

	int mem_x2=0,mem_y2=0;		//isɂӂi񂾂Ƃۂ̍W
	C_block mem_block2;			//isɂӂi񂽂Ƃۂ̃ubN
	mem_block2.setflag(0);


	switch(input[0]){
	case 'a':
		mem_x1=mPlayerX-1,mem_x2=mPlayerX-2;
		mem_y1=mPlayerY,mem_y2=mPlayerY;
		break;
	case 's':
		mem_x1=mPlayerX+1,mem_x2=mPlayerX+2;
		mem_y1=mPlayerY,mem_y2=mPlayerY;
		break;
	case 'w':
		mem_x1=mPlayerX,mem_x2=mPlayerX;
		mem_y1=mPlayerY-1,mem_y2=mPlayerY-2;
		break;
	case 'z':
		mem_x1=mPlayerX,mem_x2=mPlayerX;
		mem_y1=mPlayerY+1,mem_y2=mPlayerY+2;
		break;
	default:
		cerr<<"unacceptable command"<<endl;
		return;
		break;
	}
	//is悪}bvOȂ߂
	if(isInsideofMap(mem_x1,mem_y1)==false||isInsideofMap(mem_x2,mem_y2)==false){
		return;
	}
	//}bvȂis̃}bv𓾂
	mem_block1.setflag(mBlocks[mem_y1*mSizeX+mem_x1].getflag());
	mem_block2.setflag(mBlocks[mem_y2*mSizeX+mem_x2].getflag());

	//is悪ǂ̏ꍇ
	if(mem_block1.check(WALL)){return;}//߂

	//is悪Xy[XAו̍ڂĂȂS[̏ꍇ
	if(mem_block1.check(SPACE)||(mem_block1.check(GOAL)&&!mem_block1.check(NIMOTSU))){
		//܂̏ύX
		mBlocks[mPlayerY*mSizeX+mPlayerX].set(false,PLAYER);
		//vC[ړ
		mPlayerX=mem_x1,mPlayerY=mem_y1;
		mBlocks[mPlayerY*mSizeX+mPlayerX].set(true,PLAYER);
	}
}

void C_map::draw()const{
	for(int i=0;i<mSizeY;i++){
		for(int j=0;j<mSizeX;j++){
			mBlocks[i*mSizeX+j].draw();
		}
		cout<<endl;
	}
}